import { DataTypes, Model } from "sequelize";
import sequelize from "../database/database";

interface UserAttributes {
  user_id: string;
  master_user_id?: string;
  role: string;
  username: string;
  password: string;
  calendar_settings?: string;
}

class User extends Model<UserAttributes> implements UserAttributes {
  declare user_id: string;
  declare master_user_id: string;
  declare role: string;
  declare username: string;
  declare password: string;
  declare calendar_settings: string;
}

User.init(
  {
    // Model attributes are defined here
    user_id: {
      primaryKey: true,
      type: DataTypes.STRING,
      allowNull: false,
    },
    master_user_id: {
      type: DataTypes.STRING,
      // allowNull defaults to true
    },
    role: {
      type: DataTypes.STRING,
      // allowNull defaults to true
    },
    username: {
      type: DataTypes.STRING,
      allowNull: false,
    },
    password: {
      type: DataTypes.STRING,
      allowNull: false,
    },
    calendar_settings: {
      type: DataTypes.STRING,
      // allowNull defaults to true
    },
  },
  {
    tableName: "users",
    sequelize, // passing the `sequelize` instance is required
  }
);

export default User;
